
class Stars : public render::Renderable, public RefObject<Stars>
{
public:
  void enqueue(render::Queue& queue, const Transform3& transform) const;
  const Sphere& getBounds(void) const;
  static Stars* createInstance(float radius);
private:
  Stars(void);
  bool init(float radius);
  render::SpriteCloud3 sprites;
  Sphere bounds;
};

class StarsNode : public render::SceneNode
{
public:
  void setStars(Stars* newStars);
protected:
  void enqueue(render::Queue& queue, render::QueuePhase phase) const;
private:
  Ref<Stars> stars;
};

